#pragma once

namespace vcCalc2 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

  enum Operations {
    None, Add, Subtract, Multiply, Divide
  };

	/// <summary>
	/// Form1 ̊Tv
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^[ R[hǉ܂
			//
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
  private: System::Windows::Forms::Label^  labelMain;
  protected: 

	private:
		/// <summary>
		/// KvȃfUCi[ϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi[ T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^[ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
      this->labelMain = (gcnew System::Windows::Forms::Label());
      this->SuspendLayout();
      // 
      // labelMain
      // 
      this->labelMain->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
      this->labelMain->Location = System::Drawing::Point(13, 13);
      this->labelMain->Name = L"labelMain";
      this->labelMain->Size = System::Drawing::Size(152, 23);
      this->labelMain->TabIndex = 0;
      this->labelMain->Text = L"label1";
      this->labelMain->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
      // 
      // Form1
      // 
      this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
      this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
      this->ClientSize = System::Drawing::Size(176, 206);
      this->Controls->Add(this->labelMain);
      this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
      this->MaximizeBox = false;
      this->Name = L"Form1";
      this->Text = L"d";
      this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
      this->ResumeLayout(false);

    }
#pragma endregion
  Operations Operation;
  double DisplayValueValue, HiddenValue;
  property double DisplayValue {
    double get() {
      return DisplayValueValue;
    }
    void set(double value) {
      DisplayValueValue = value;
      if (!(labelMain->Text->Contains(".") && labelMain->Text->EndsWith("0"))) {
        labelMain->Text = value.ToString();
      }
    }
  }
  bool IsNewValue;

  private: System::Void Form1_Load(System::Object^  sender, 
    System::EventArgs^  e) {
    
    String^ buttonText = "789/456*123-0C=+";
	const int buttonWidth = 36;
	const int buttonInterval = 40;
	const int startPositionX = 10;
	const int startPositionY = 40;
    
    Button^ b;
    for (int i = 0; i < 4; i++) {
      for (int j = 0; j < 4; j++) {
        b = gcnew Button;
        b->Size = Drawing::Size(buttonWidth, buttonWidth);
        b->Text = buttonText->Substring(i * 4 + j, 1);
        b->Location = Drawing::Point(
          startPositionX + buttonInterval * j,
          startPositionY + buttonInterval * i);
          b->Click += gcnew System::EventHandler(
            this, &Form1::ButtonClick);
          this->Controls->Add(b);
      }
    }
    Initialize();
  }

  private: void Initialize() {
    HiddenValue = 0;
    DisplayValue = 0;
    IsNewValue = true;
    Operation = None;
  }

  private: System::Void ButtonClick(System::Object^  
    sender, System::EventArgs^  e) {
    
    Button^ button = (Button^)sender;
    wchar_t c = button->Text[0];
    switch (c) {
      case '+':
        UpdateValues();
        Operation = Add;
        break;
      case '-':
        UpdateValues();
        Operation = Subtract;
        break;
      case '*':
        UpdateValues();
        Operation = Multiply;
        break;
      case '/':
        UpdateValues();
        Operation = Divide;
        break;
      case '=':
        UpdateValues();
        Operation = None;
        break;
      case 'C':
        Initialize();
        UpdateValues();
        break;
      case '0': case '1': case '2': case '3': case '4': case '5':
      case '6': case '7': case '8': case '9':
        if (IsNewValue) labelMain->Text = "";
        labelMain->Text += c;
        DisplayValue = System::Double::Parse(labelMain->Text);
        IsNewValue = false;
        break;
    }
  }
  
  private: void UpdateValues() {
    if (!IsNewValue) {
      switch (Operation) {
        case None:
          HiddenValue = DisplayValue;
          break;
        case Add:
          HiddenValue = HiddenValue + DisplayValue;
          break;
        case Subtract:
          HiddenValue = HiddenValue - DisplayValue;
          break;
        case Multiply:
          HiddenValue = HiddenValue * DisplayValue;
          break;
        case Divide:
          HiddenValue = HiddenValue / DisplayValue;
          break;
      }
      IsNewValue = true;
      DisplayValue = HiddenValue;
    }
  }
};
}

